## trunk?format=zip&rev=1198

=== SConstruct ===
import os
import sys
import distutils.sysconfig
import platform
import SCons
# scons plug-ins
#from installtree import InstallTree

moduledir = distutils.sysconfig.get_python_lib()
if  platform.architecture()[0] == '64bit':
    # hack to install into /usr/lib64 if scons is in the 32bit /usr/lib/
    if moduledir.startswith("/usr/lib/"):
        moduledir = moduledir.replace("lib", "lib64")

opts = Options("userconfig.py")
opts.AddOptions(PathOption("prefix",
                           "The root installation path",
                           distutils.sysconfig.PREFIX),
                PathOption("moduledir",
                            "The python module path (site-packages))",
                            moduledir),
                ("rpfitsdir", "Alternative rpfits location.", ""),
                ("cfitsioincdir", "Alternative cfitsio include dir", ""),
                ("casadir", "Alternative casa location", ""),
                EnumOption("mode", "The type of build.", "debug",
                           ["release","debug"], ignorecase=1),
                ("makedist",
                 "Make a binary archive giving a suffix, e.g. sarge or fc5",
                 "")
                )

env = Environment( toolpath = ['./scons'],
                   tools = ["default", "casa", "archiver", "utils",
                            "quietinstall"],
                   ENV = { 'PATH' : os.environ[ 'PATH' ],
                          'HOME' : os.environ[ 'HOME' ] },
                   options = opts)

Help(opts.GenerateHelpText(env))
env.SConsignFile()
env.Append(CASAARCH = '', CASAROOT = '')
if (os.path.exists(env["cfitsioincdir"])):
    env.Append(CPPPATH=[env["cfitsioincdir"]])
env.AddCustomPath(env["rpfitsdir"])
if not env.GetOption('clean'):
    conf = Configure(env)
    # import Custom tests
    env.AddCasaTest(conf)
    pylib = 'python'+distutils.sysconfig.get_python_version()
    pyinc = "Python.h"
    if env['PLATFORM'] == "darwin":
        pylib = "Python"
    if not conf.CheckLib(library=pylib, language='c'): Exit(1)
    conf.env.Append(CPPPATH=[distutils.sysconfig.get_python_inc()])
    if not conf.CheckHeader("Python.h", language='c'):
        Exit(1)
    if not conf.CheckLibWithHeader('boost_python', 'boost/python.hpp', 'c++'): Exit(1)
    conf.env.AddCustomPath(env["rpfitsdir"])
    if not conf.CheckLib('rpfits'): Exit(1)
    # cfitsio is either in include/ or /include/cfitsio
    # handle this
    if not conf.CheckLib(library='cfitsio', language='c'): Exit(1)
    if not conf.CheckHeader('fitsio.h', language='c'):
        if not conf.CheckHeader('cfitsio/fitsio.h', language='c'):
            Exit(1)
        else:
            conf.env.Append(CPPPATH=['/usr/include/cfitsio'])
    if (sys.platform == "darwin"):
        conf.env.Append(LIBS = ['-framework vecLib'])
    else:
        if not conf.CheckLib('lapack'): Exit(1)
        if not conf.CheckLib('blas'): Exit(1)
    if not conf.CheckLib('g2c'): Exit(1)
    if not conf.CheckLib('stdc++', language='c++'): Exit(1)
    if not conf.CheckCasa(env["casadir"]): Exit(1)
    env = conf.Finish()

env["version"] = "2.1.0b"

# general CPPFLAGS
env.Append(CPPFLAGS=['-D_FILE_OFFSET_BITS=64', '-D_LARGEFILE_SOURCE', '-O3'])

# 64bit flags
if  platform.architecture()[0] == '64bit':
    env.Append(CPPFLAGS=['-fPIC', '-D__x86_64__', '-DAIPS_64B'])

if env['mode'] == 'release':
    env.Append(LINKFLAGS=['-Wl,-O1'])

# Export for SConscript files
Export("env")

# build library
so = env.SConscript("src/SConscript", build_dir="build", duplicate=0)
# test module import, to see if there are unresolved symbols
def test_module(target,source,env):
    pth = str(target[0])
    mod = os.path.splitext(pth)[0]
    sys.path.insert(2, os.path.split(mod)[0])
    __import__(os.path.split(mod)[1])
    print "ok"
    return 0
def test_str(target, source, env):
    return "Testing module..."

taction = Action(test_module, test_str)
env.AddPostAction(so, taction)

# install targets
somod = env.Install("$moduledir/asap", so )
pymods = env.Install("$moduledir/asap", env.SGlob("python/*.py"))
bins = env.Install("$prefix/bin", ["bin/asap", "bin/asap_update_data"])
shares = env.Install("$moduledir/asap/data", "share/ipythonrc-asap")
env.Alias('install', [somod, pymods, bins, shares])

# install aips++ data repos
rootdir=None
outdir =  os.path.join(env["moduledir"],'asap','data')
sources = ['ephemerides','geodetic']
if os.path.exists("/nfs/aips++/data"):
    rootdir = "/nfs/aips++/data"
elif os.path.exists("data"):
    rootdir = "./data"
if rootdir is not None:
    ofiles, ifiles = env.WalkDirTree(outdir, rootdir, sources)
    data =  env.InstallAs(ofiles, ifiles)
    env.Alias('install', data)
    
# make binary distribution
if len(env["makedist"]):
    env["stagedir"] = "asap-%s-%s" % (env["version"], env["makedist"])
    env.Command('Staging distribution for archive in %s' % env["stagedir"],
                '', env.MessageAction)
    st0 = env.QInstall("$stagedir/asap", [so,  env.SGlob("python/*.py")] )
    env.QInstall("$stagedir/bin", ["bin/asap", "bin/asap_update_data"])
    env.QInstall("$stagedir", ["bin/install"])
    env.QInstall("$stagedir/asap/data", "share/ipythonrc-asap")
    if rootdir is not None:
        env.Command("Using data tables in %s" % rootdir,
                    '', env.MessageAction)        
        outdir =  os.path.join(env["stagedir"],'asap','data')
        ofiles, ifiles = env.WalkDirTree(outdir, rootdir, sources)
        env.QInstallAs(ofiles, ifiles)
    else:
        env.Command("No data tables available. Use 'asap_update_data' after install",
                    '', env.MessageAction)        
    arch = env.Archiver(os.path.join("dist",env["stagedir"]),
                        env["stagedir"])
    env.AddPostAction(arch, Delete("$stagedir"))

if env.GetOption("clean"):
    Execute(Delete(".sconf_temp"))

=== packages/sipb-xen-base/debian/changelog ===
sipb-xen-base (8.23) unstable; urgency=low

  * Now that we're using Python 2.5, we can actually write with statements

 -- Evan Broder <broder@mit.edu>  Fri, 24 Oct 2008 03:32:00 -0400

sipb-xen-base (8.22) unstable; urgency=low

  * Please - anything but etch. Anything!

 -- Evan Broder <broder@mit.edu>  Thu, 02 Oct 2008 19:50:30 -0400

sipb-xen-base (8.21) unstable; urgency=low

  * update sources.list.d/sipb-xen.list for prod and hardy

 -- Greg Price <price@mit.edu>  Wed, 01 Oct 2008 20:06:52 -0400

sipb-xen-base (8.20) unstable; urgency=low

  * fix distribution

 -- Greg Price <price@mit.edu>  Tue, 30 Sep 2008 23:51:11 -0400

sipb-xen-base (8.19) hardy; urgency=low

  * depend on invirt-config, which is provided by xvm-devconfig
    and xvm-prodconfig.

 -- Greg Price <price@mit.edu>  Mon, 29 Sep 2008 06:03:54 +0000

sipb-xen-base (8.18) unstable; urgency=low

  * Use production k5login
  * Include openafs component

 -- Sam Hartman <hartmans@debian.org>  Fri, 22 Aug 2008 16:37:01 -0400

sipb-xen-base (8.17) unstable; urgency=low

  * removed the `mako` program since python-mako already includes a
    mako-render

 -- Yang Zhang <y_z@mit.edu>  Wed, 13 Aug 2008 01:45:26 -0400

sipb-xen-base (8.16) unstable; urgency=low

  * added `mako` program for processing templates in invirt packages

 -- Yang Zhang <y_z@mit.edu>  Tue, 12 Aug 2008 16:00:43 -0400

sipb-xen-base (8.15) unstable; urgency=low

  * put invirt-getconf in /usr/bin

 -- Greg Price <price@mit.edu>  Sat,  2 Aug 2008 21:58:36 -0400

sipb-xen-base (8.14) unstable; urgency=low

  * using correct default paths in invirt-getconf
  * fixed os.rename import bug

 -- Yang Zhang <y_z@mit.edu>  Sat,  2 Aug 2008 20:29:56 -0400

sipb-xen-base (8.13) unstable; urgency=low

  * fix an error message

 -- Greg Price <price@mit.edu>  Wed, 30 Jul 2008 23:04:07 -0400

sipb-xen-base (8.12) unstable; urgency=low

  [ Greg Price ]
  * add --ls and some convenience features to invirt-getconf:
    formatting composite nodes as yaml, allowing the root
  * fix bug in late-import of yaml in invirt.config
  * use yaml.CSafeDumper and yaml.CSafeLoader everywhere
  
  [ Yang Zhang ]
  * added shared lock around cache-reading transaction

 -- Greg Price <price@mit.edu>  Wed, 30 Jul 2008 22:11:15 -0400

sipb-xen-base (8.11) unstable; urgency=low

  * sped up invirt.config module load time by rearranging imports
  * no longer removing the lock file

 -- Yang Zhang <y_z@mit.edu>  Wed, 30 Jul 2008 21:55:23 -0400

sipb-xen-base (8.10) unstable; urgency=low

  * added file locking around cache

 -- Yang Zhang <y_z@mit.edu>  Tue, 29 Jul 2008 22:35:25 -0400

sipb-xen-base (8.9) unstable; urgency=low

  * moved more generic code into `common` package
  * silently fail if cache fails
  * load the configuration on module load
  * produce a struct-based representation of the configuration
  * allowing full exception messages for OSErrors (default behavior)
  * added some dependencies specs

 -- Yang Zhang <y_z@mit.edu>  Tue, 29 Jul 2008 01:03:16 -0400

sipb-xen-base (8.8) unstable; urgency=low

  * added timestamp-based JSON caching of configuration for faster loading
  * exposed (more) options to command-line frontend
  * improved error messages/handling/help
  * removed all python 2.5-isms
  * reformatted to fit project style conventions

 -- Yang Zhang <y_z@mit.edu>  Mon, 28 Jul 2008 12:25:03 -0400

sipb-xen-base (8.7) unstable; urgency=low

  * back to 2.4 compatibility

 -- Greg Price <price@mit.edu>  Mon, 28 Jul 2008 07:44:27 -0400

sipb-xen-base (8.6) unstable; urgency=low

  * switching to python 2.5 only
  * added y_z to .k5login

 -- Yang Zhang <y_z@mit.edu>  Sun, 27 Jul 2008 20:23:54 -0400

sipb-xen-base (8.5) unstable; urgency=low

  * using python 2.5
  * initial working version of invirt-getconf that reads & navigates YAML

 -- Yang Zhang <y_z@linerva.mit.edu>  Sun, 27 Jul 2008 20:12:28 -0400

sipb-xen-base (8.4) unstable; urgency=low

  [ Greg Price ]
  * begin a Python package 'invirt'

  [ Yang Zhang ]
  * added invirt-getconf to read configuration files

 -- Yang Zhang <y_z@mit.edu>  Sun, 27 Jul 2008 19:10:10 -0400

sipb-xen-base (8.3) unstable; urgency=low

  * add invirt-reload to regenerate and reload configs

 -- Greg Price <price@mit.edu>  Mon, 21 Jul 2008 20:35:42 -0400

sipb-xen-base (8.2) unstable; urgency=low

  * leave out debathena-system so we get only the packages we ask for

 -- Greg Price <price@mit.edu>  Sun, 20 Jul 2008 13:58:52 -0400

sipb-xen-base (8.1) unstable; urgency=low

  * include debathena to make stuff like kerberos config easier

 -- Greg Price <price@mit.edu>  Sat, 19 Jul 2008 23:16:47 -0400

sipb-xen-base (8) unstable; urgency=low

  * update .k5login to match black-mesa

 -- Greg Price <price@mit.edu>  Sun,  4 May 2008 20:28:28 -0400

sipb-xen-base (7) unstable; urgency=low

  * include backports.org
  * sources.list.d doesn't actually need a .sources.list, just .list

 -- Greg Price <price@mit.edu>  Thu,  1 May 2008 19:45:50 -0400

sipb-xen-base (6) unstable; urgency=low

  * actually use sources.list.d correctly

 -- Greg Price <price@mit.edu>  Sat, 26 Apr 2008 21:22:12 -0400

sipb-xen-base (5) unstable; urgency=low

  * update sources.list, use sources.list.d

 -- Greg Price <price@mit.edu>  Sat, 26 Apr 2008 21:06:05 -0400

sipb-xen-base (4) unstable; urgency=low

  * sipb-vm-1 becomes sipb-xen-dev

 -- Sam Hartman <hartmans@debian.org>  Tue,  4 Sep 2007 15:48:50 -0400

sipb-xen-base (3) unstable; urgency=low

  * We want security updates too

 -- Sam Hartman <hartmans@debian.org>  Fri, 10 Aug 2007 20:39:14 -0400

sipb-xen-base (2) unstable; urgency=low

  * Update sources.list to include our debian mirror

 -- Sam Hartman <hartmans@debian.org>  Sat,  4 Aug 2007 19:11:18 -0400

sipb-xen-base (1) unstable; urgency=low

  * New upstream version

 -- Sam Hartman <hartmans@debian.org>  Sat,  4 Aug 2007 18:44:21 -0400

=== packages/sipb-xen-base/debian/control ===
Source: sipb-xen-base
Section: base
Priority: extra
Maintainer: SIPB Xen Project <sipb-xen@mit.edu>
Build-Depends: cdbs (>= 0.4.23-1.1), debhelper (>= 4.1.0), python-support
Standards-Version: 3.8.0

Package: sipb-xen-base
Architecture: all
Depends: ${misc:Depends}, python-json (>= 3.4-2), python-yaml (>= 3.05), python-mako (>= 0.2.2), invirt-config
Description: Base configuration required for all SIPB xen servers
 This package includes apt configuration, .k5login and other files that
 should be synchronized among all our servers.
 Installing this on a non-sipb-xen machine would be very anti-social.
